/*~******************************************************************************************
*	~Project:	"BusTown"																	*
*	~Author:	Tim "BlackBird" Beaudet														*
*	~Modified:	1/13/2012																	*
******************************************************************************************~*/

package
{
	import defines.Assets;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.graphics.Text;
	import net.flashpunk.utils.Input;
	import net.flashpunk.utils.Key;
	import net.flashpunk.World;
	import net.flashpunk.FP;
	
	import ui.MuteSoundsBtn;
	import ui.GotoLevelsBtn;
	
	public class GameResults extends World
	{
		private var mWin:Boolean = true;
		private var mTitleImage:Image;

		//private var mLabelTxt:Text = new Text("Reached Safety:\nFell to doom:\n\nDays:\nActions:\nUnused Actions:\n\nTotal Saved:", 300, 350);
		//private var mScoreTxt:Text = new Text("Scores\nOver\n1929\n42", 450, 350);
		private var mLabelTxt:Text = new Text("Reached Safety\nFell to doom\n\nDays\nActions\nUnused Actions\n\nTotal Saved", 350, 350);
		private var mScoreTxt:Text = new Text("Scores\nOver\n1929\n42", 300, 350);
		private var mClickToContinue:Text = new Text("Click in-game to select next level.", FP.screen.width / 2.0, 580);
		
		private var mTotalKidCount:int = 0;
		
		public function GameResults(win:Boolean):void
		{
			mTitleImage = new Image(Assets.GAME_WINLOSE, new Rectangle(0, (win) ? 0 : 300, 800, 300));
			addGraphic(mTitleImage);
			add(new MuteSoundsBtn());
			//add(new GotoLevelsBtn(750, 550));
			
			GetResults();
			mLabelTxt.scale = mScoreTxt.scale = 1.333;
			addGraphic(mLabelTxt);
			addGraphic(mScoreTxt);
			
			mClickToContinue.centerOrigin();
			addGraphic(mClickToContinue);
		}
	
		private function GetResults():void
		{
			var game:GameWorld = GameWorld.GetInstance();
			var atX:Number = mScoreTxt.x;
			var atY:Number = mScoreTxt.y;
			mScoreTxt = new Text( game.GetNumKidsSaved() + "\n" + (game.GetNumKidsAtStart() - game.GetNumKidsSaved()) + "\n\n" + game.GetRoundsPlayed() + "\n" + game.GetTotalActionsUsed() + "\n" +
				game.GetTotalActionsUnused() + "\n\n" + game.GetTotalNumberKidsSaved(),	atX, atY);
		}
		
		override public function render():void
		{
			super.render();
//			if (true == mWin)
//				FP.buffer.fillRect(new Rectangle(0, 0, 800, 600), 0xFF339933);
//			else
//				FP.buffer.fillRect(new Rectangle(0, 0, 800, 600), 0xFF993333);


//			if (-1 == mMessageText.search("\n"))
//				label.render(FP.buffer, new Point(x - (txt.width * 0.5), y - (mMessageBox.height * 0.5) + 10), world.camera);

		}
		
		override public function update():void
		{
			super.update();
			if (true == Input.mousePressed)
				FP.world = new LevelSelect();
		}
	}
}