/*~******************************************************************************************
*	~Project:	"TinyWorld"																	*
*	~Author:	Tim "BlackBird" Beaudet														*
*	~Modified:	4/20/2012																	*
******************************************************************************************~*/

package
{
	import net.flashpunk.Engine;
	import net.flashpunk.World;
	import net.flashpunk.FP;
	
	import flash.system.System;
	import flash.events.Event;
	import flash.events.MouseEvent;
	
	import defines.Assets;
	
	public class Main extends Engine
	{
		public function Main():void
		{
			super(800, 600, 60, false);
			FP.world = new SplashScreen();
		
			if (Assets.IS_DEV_MODE)
			{
				this.addEventListener(MouseEvent.MOUSE_DOWN, onMouseDown);
			}
		}
		
		override public function init():void
		{
			trace("TinyWorld Init.");
			super.init();
		}
		
		

		private function onMouseDown(e:MouseEvent):void
		{
			//var saveData:ByteArray = new ByteArray();
			//saveData.writeUTFBytes("some data to be saved.");
		
			if (Assets.IS_DEV_MODE)
			{
				if (null != GameEditor.Instance && true == GameEditor.Instance.ReadyToSave())
					System.setClipboard(GameEditor.Instance.MakeSaveString());
			}
		}
		
		private function onSelect(e:Event):void { trace("select"); }
		private function onCancel(e:Event):void { trace("cancel"); }
		
	}
}