/*~******************************************************************************************
*	~Project:	"BusTown"																	*
*	~Author:	Tim "BlackBird" Beaudet														*
*	~Modified:	1/13/2012																	*
******************************************************************************************~*/

package
{
	import defines.Assets;
	import flash.geom.Rectangle;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.utils.Input;
	import net.flashpunk.utils.Key;
	import net.flashpunk.World;
	import net.flashpunk.FP;
	
	public class SplashScreen extends World
	{
		private const BEGIN_FADEOUT:Number = 1.0;
		private const FINISH_FADEIN:Number = 4.0;
		
		private var mPresentsLogo:Image = new Image(Assets.LOGO_WEPRESENT);
		private var mBlackBirdLogo:Image = new Image(Assets.LOGO_BLACKBIRD);
		private var mJoeKinleyLogo:Image = new Image(Assets.LOGO_JOEKINLEY);
		
		private var mTimer:Number = 5.0;

		public function SplashScreen():void
		{
			var xCenter:Number = FP.screen.width * 0.5;
			mPresentsLogo.x = xCenter;		mPresentsLogo.y = 400 + 64;
			mPresentsLogo.centerOrigin();
			
			mBlackBirdLogo.x = xCenter - 180;	mBlackBirdLogo.y = 200;
			mBlackBirdLogo.scaleX = 0.5;	mBlackBirdLogo.scaleY = 0.5;
			mBlackBirdLogo.centerOrigin();

			mJoeKinleyLogo.x = xCenter + 180;	mJoeKinleyLogo.y = 200;
			mJoeKinleyLogo.scaleX = 0.5;	mJoeKinleyLogo.scaleY = 0.5;
			mJoeKinleyLogo.centerOrigin();
			
			FP.screen.color = 0xFF5C91F9;
			addGraphic(mPresentsLogo);
			addGraphic(mBlackBirdLogo);
			addGraphic(mJoeKinleyLogo);
		}
		
		private function OnFinished():void
		{
			FP.world = new LevelSelect();
		}
		
		override public function update():void
		{
			if (true == Assets.IS_DEV_MODE && (Input.pressed(Key.P) || Input.pressed(Key.E)))
				OnFinished();
				
			mTimer -= FP.elapsed;
			if (mTimer < 0.0)
				OnFinished();
			
			var a:Number = 1.0;
			if (mTimer < BEGIN_FADEOUT)
				a = mTimer / BEGIN_FADEOUT;
			if (mTimer > FINISH_FADEIN)
				a = 1.0 - (mTimer - FINISH_FADEIN);
				
			mPresentsLogo.alpha = a;
			mBlackBirdLogo.alpha = a;
			mJoeKinleyLogo.alpha = a;
		}
		
		override public function render():void
		{
			super.render();
		}
	}
}