/*~******************************************************************************************
*	~Project:	"BusTown"																	*
*	~Author:	Tim "BlackBird" Beaudet														*
*	~Modified:	1/13/2012																	*
******************************************************************************************~*/

package defines
{
	import net.flashpunk.Sfx;
	
	public class Assets
	{
		public static const IS_DEV_MODE:Boolean = false;

		[Embed(source = '../../data/WePresentLogo.png')] public static const LOGO_WEPRESENT:Class;
		[Embed(source = '../../data/BlackBirdLogo.png')] public static const LOGO_BLACKBIRD:Class;
		[Embed(source = '../../data/JoeKinleyLogo.png')] public static const LOGO_JOEKINLEY:Class;
		[Embed(source = '../../data/title.png')] public static const GAME_TITLE:Class;
		
		[Embed(source = '../../data/ui.png')] public static const GAME_INTERFACE:Class;
		[Embed(source = '../../data/winlose.png')] public static const GAME_WINLOSE:Class;
		[Embed(source = '../../data/tileset.png')] public static const HEXAGON_TILESET_SD:Class;
		
		[Embed(source = '../../data/spritesheet.png')] public static const TINYKID_SHEET:Class;
		[Embed(source = '../../data/falling.mp3')] public static const SFX_TINYKID_ONDEATH:Class;
		[Embed(source = '../../data/save.mp3')] public static const SFX_TINYKID_ONSAFETY:Class;
		[Embed(source = '../../data/drop.mp3')] public static const SFX_TINYKID_ONUNGRAB:Class;
		
		[Embed(source = '../../data/bgmusic.mp3')] public static const MUSIC_BACKGROUND:Class;
		[Embed(source = '../../data/popup_open.mp3')] public static const SFX_POPUP_OPEN:Class;
		[Embed(source = '../../data/popup_close.mp3')] public static const SFX_POPUP_CLOSE:Class;
		
		[Embed(source = '../../data/click.mp3')] public static const SFX_BUTTON_PRESS:Class;
		[Embed(source = '../../data/big_crack.mp3')] public static const SFX_CRACKING_BIG:Class;
		[Embed(source = '../../data/little_crack.mp3')] public static const SFX_CRACKING_SMALL:Class;

		//---------------------
		public static const inSfxButtonClick:Sfx = new Sfx(SFX_BUTTON_PRESS);
		public static const inSfxCrackingBig:Sfx = new Sfx(SFX_CRACKING_BIG);
		public static const inSfxCrackingSmall:Sfx = new Sfx(SFX_CRACKING_SMALL);
		public static const inSfxOnUngrabKid:Sfx = new Sfx(Assets.SFX_TINYKID_ONUNGRAB);
				
		public static const arrSfxCrackingSmall:Array = new Array(new Sfx(SFX_CRACKING_SMALL), new Sfx(SFX_CRACKING_SMALL), new Sfx(SFX_CRACKING_SMALL));
		public static const arrSfxCrackingBig:Array = new Array(new Sfx(SFX_CRACKING_BIG), new Sfx(SFX_CRACKING_BIG), new Sfx(SFX_CRACKING_BIG));
		
		public static function PlaySoundIn(snd:Sfx, vol:Number = 1.0, pan:Number = 0.0):void
		{
			if (false == snd.playing)
				snd.play(vol, pan);
		}
		
		public static function PlaySoundArr(snd:Array, vol:Number = 1.0, pan:Number = 0.0):void
		{
			var idx:int = -1;
			for (var i:int = 0; idx == -1 && i < snd.length; ++i)
				if (false == snd[i].playing)
					idx = i;
					
			if (idx != -1)
				snd[idx].play(vol, pan);
		}
		
	}
}