package gameobjs
{
	import defines.Assets;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import map.HexagonTile;
	import map.HexagonMap;
	import map.MapInfo;
	import net.flashpunk.utils.Input;
	
	import net.flashpunk.FP;
	import net.flashpunk.Entity;
	import net.flashpunk.graphics.Image;
	
	public class FallingTile extends Entity
	{
		private const FULL_FALLTIME:Number = 1.0;
		private var mImage:Image = null;
		private var mFallingTimer:Number = FULL_FALLTIME;
		private var mScale:Number = 1.0;
		
		public function FallingTile(tile:HexagonTile, info:MapInfo, hexMap:HexagonMap)
		{
			x = tile.pos.x;
			y = tile.pos.y;
			
			mImage = hexMap.GetTileImageOf(tile.type, 1);
		}
		
		public override function update():void
		{
			if (null == mImage)
				world.remove(this);
				
			mFallingTimer -= FP.elapsed;
			if (mFallingTimer < 0.0)
			{
				world.remove(this);
				GameWorld.WaitToFinish--;
			}
			
			mScale = mFallingTimer / FULL_FALLTIME;
		}
		
		public override function render():void
		{
			super.render();
			
			if (null == mImage)
				return;
				
			var origScale:Number = mImage.scale;
			mImage.scale = mScale;
			mImage.render(FP.buffer, new Point(x, y), world.camera);
			mImage.scale = origScale;
		}
	}
}