package gameobjs
{
	import defines.Assets;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import map.HexagonTile;
	import map.HexagonMap;
	import map.MapInfo;
	import net.flashpunk.utils.Input;
	
	import net.flashpunk.FP;
	import net.flashpunk.Entity;
	import net.flashpunk.graphics.Image;
	
	public class RemoveAction extends Entity
	{
		private static const GOAL_X:Number = 100;
		private static const GOAL_Y:Number = 580;
		private static const MOVE_SPEED:Number = 400;
		
		private static var mImage:Image = new Image(Assets.GAME_INTERFACE, new Rectangle(128, 0, 64, 64));
		
		public function RemoveAction(atX:Number, atY:Number)
		{
			x = atX;	y = atY;
			addGraphic(mImage);
			mImage.scale = 0.25;
		}
		
		public override function update():void
		{
			var moveAmt:Number = MOVE_SPEED * FP.elapsed;
			moveTowards(GOAL_X, GOAL_Y, moveAmt);
			if (distanceToPoint(GOAL_X, GOAL_Y, false) < moveAmt)
				OnComplete();
		}
		
		private function OnComplete():void
		{
			var gw:GameWorld = GameWorld.GetInstance();
			var num:int = gw.GetDisplayedActionsLeft();
			gw.SetDisplayedActionsLeft(num - 1);
			
			world.remove(this);
		}
	}
}