package ui
{
	import defines.Assets;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import net.flashpunk.Entity;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.graphics.Text;
	import net.flashpunk.Tween;
	import net.flashpunk.utils.Input;
	import net.flashpunk.FP;

	public class Display extends Entity
	{
		private static const BOUNCE_TIME:Number = 1.0;
		private static const INV_BOUNCE_TIME:Number = 1.0 / 0.3;
		private var mBounceTimer:Number = 0.0;
		
		protected var mActionsText:Text = new Text("");
		protected var mActionsNumber:Text = new Text("1");
		protected var mGameWorld:GameWorld = null;
		
		private var mKidNeeded:Image = new Image(Assets.GAME_INTERFACE, new Rectangle(320 + 32, 0, 32, 32));
		private var mKidSaved:Image = new Image(Assets.GAME_INTERFACE, new Rectangle(320, 0, 32, 32));
		
		protected var mLastActionsLeft:int = 0;
		
		public function Display(gw:GameWorld)
		{
			mGameWorld = gw;
			x = 50;		y = 550;
//			mActionsIcon.centerOrigin();
			mActionsText.x = x + 40;
			mActionsText.y = y - 32;
			mActionsText.scale = 2;
			
//			addGraphic(mActionsIcon);

			mLastActionsLeft = mGameWorld.GetActionsLeft();
		}
	
		public override function update():void
		{
			mActionsText.text = "Day: " + (mGameWorld.GetRoundsPlayed() + 1) + "\nActions: ";// + mGameWorld.GetDisplayedActionsLeft();

			var numActs:int = mGameWorld.GetDisplayedActionsLeft();
			if (mLastActionsLeft - numActs > 0)
			{
				mBounceTimer = BOUNCE_TIME;
			}
			
			if (mBounceTimer > 0.0)
			{
				mBounceTimer -= FP.elapsed * 3;
				if (mBounceTimer < 0.0)
					mBounceTimer = 0.0;
			}
			
			
			mLastActionsLeft = numActs;
			
			mActionsNumber.x = mActionsText.x + mActionsText.scaledWidth;
			mActionsNumber.y = mActionsText.y - (Math.sin((mBounceTimer) * Math.PI) * 10);
			mActionsNumber.scale = mActionsText.scale;
			
			mActionsNumber.text = "\n" + numActs;
		}
		
		public override function render():void
		{
			super.render();
			
			var pt:Point = new Point(0, 0);
			mActionsText.render(FP.buffer, pt, mGameWorld.camera);
			mActionsNumber.render(FP.buffer, pt, mGameWorld.camera);
			
			var centerX:Number = 400.0 - (Math.max(mGameWorld.GetNumKidsSaved(), mGameWorld.GetNumKidsToSave()) * 20);
			pt.y = 550;
			pt.x = centerX;
			for (var i:int = 0 ; i < mGameWorld.GetNumKidsToSave(); ++i, pt.x += 40.0)
				mKidNeeded.render(FP.buffer, pt, mGameWorld.camera);

			pt.x = centerX;
			for (i = 0; i < mGameWorld.GetNumKidsSaved(); ++i, pt.x += 40.0)
				mKidSaved.render(FP.buffer, pt, mGameWorld.camera);
		}
	}
}