package ui
{
	import defines.Assets;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import net.flashpunk.Entity;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.graphics.Text;
	import net.flashpunk.utils.Input;
	import net.flashpunk.FP;

	public class GameTutorial extends Entity
	{
		public static var Completed:Boolean = (Assets.IS_DEV_MODE) ? true : false;
				
		public static var shownMovement:Boolean = false;
		public static var shownMoveCosts:Boolean = false;
		public static var shownGroundCracks:Boolean = false;
		public static var shownActionSkip:Boolean = false;
		public static var shownLevelRestart:Boolean = false;
		
		public static var timeSinceStart:Number = 0.0;

		private var mGameWorld:GameWorld = null;
		
		public function GameTutorial(gameWorld:GameWorld)
		{
			mGameWorld = gameWorld;
		}
		
		public override function update():void
		{
			super.update();
			timeSinceStart += FP.elapsed;
			
			if (true == Completed)
				return;

			//	Tutorial: Movement
			//
			///////////////////////////////////////////////////////////////////////////////////////////
			if (false == shownMovement && 0 == mGameWorld.GetRoundsPlayed())
			{	//Check if the player has made their first move of the game on their own.
				if (timeSinceStart > 10.0 && 0 == mGameWorld.GetRoundsPlayed() && mGameWorld.GetActionsPerRound() == mGameWorld.GetActionsLeft())
				{
					shownMovement = true;
					PopupBox.ShowMsg("Movement:\n\nDrag and drop the kid.\n");
				}
			}
			if (mGameWorld.GetActionsLeft() < mGameWorld.GetActionsPerRound() || mGameWorld.GetRoundsPlayed())
			{	//The player was smart enough to figure out how to move on their own.
				shownMovement = true;
			}

			
			//	Tutorial: Movement Cost
			//
			///////////////////////////////////////////////////////////////////////////////////////////
			if (false == shownMoveCosts && 1 == mGameWorld.GetRoundsPlayed())
			{
				PopupBox.ShowMsg("Cost for Movement:\n\nDirt Path = 1 action.\nGrassy Field = 2 actions.\nMountains = No Movement");
				shownMoveCosts = true;
			}

			
			//	Tutorial: Ground Cracks
			//
			///////////////////////////////////////////////////////////////////////////////////////////
			if (false == shownGroundCracks && 2 == mGameWorld.GetRoundsPlayed() && 1 == mGameWorld.GetCurrentLevel())
			{
				PopupBox.ShowMsg("Cracking Grounds:\n\nCracks are warning signs\nthat show where the ground\nwill fall soon.\n\nWalk on them as you dare.");
				shownGroundCracks = true;
			}
			
			
			//	Tutorial: Action Skipping
			//
			///////////////////////////////////////////////////////////////////////////////////////////
			if (false == shownActionSkip && 4 == mGameWorld.GetRoundsPlayed() && 1 == mGameWorld.GetCurrentLevel())
			{
				PopupBox.ShowMsg("Skipping Actions:\n\nYou can skip to the end\nof the day by clicking\nthe button on the lower-left.\n\nResults show unused actions.");
				shownActionSkip = true;
			}
			
			
			//	Tutorial: Restarting Level
			//
			///////////////////////////////////////////////////////////////////////////////////////////
			if (false == shownLevelRestart && 5 == mGameWorld.GetRoundsPlayed() && 1 == mGameWorld.GetCurrentLevel())
			{
				PopupBox.ShowMsg("Restarting Level:\n\nFind yourself stuck?\nRestart by clicking the\nbutton on the lower-right.");
				shownLevelRestart = true;
			}
		}
	}
}