package ui
{
	import defines.Assets;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import net.flashpunk.Entity;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.graphics.Text;
	import net.flashpunk.Sfx;
	import net.flashpunk.utils.Input;
	import net.flashpunk.FP;
	import net.flashpunk.utils.Key;

	public class PopupBox extends Entity
	{
		private static const mSfxOnOpen:Sfx = new Sfx(Assets.SFX_POPUP_OPEN);
		private static const mSfxOnClose:Sfx = new Sfx(Assets.SFX_POPUP_CLOSE);
		protected static var mMessageBox:Image = new Image(Assets.GAME_INTERFACE, new Rectangle(0, 64, 256, 128));
		protected static var mMessageText:String = "Some Message";
		
		public function PopupBox()
		{
			x = FP.screen.width * 0.5;
			y = FP.screen.height * 0.5;
			
			mMessageBox.centerOrigin();
			addGraphic(mMessageBox);
			
			OnHide(false);
		}
		
		public static function ShowMsg(msg:String):void
		{
			mMessageText = msg;
			OnShow();
		}
		
		public static function IsShowing():Boolean { return mMessageBox.visible; }
		
		public override function update():void
		{
			super.update();
			
			if (false == IsShowing())
				return;
				
			world.bringToFront(this);
			
			var mx:Number = Input.mouseX - x;
			var my:Number = Input.mouseY - y;
			if ((true == Input.mousePressed && mx > -128 && mx < 128 && my > -64 && my < 64) || true == Input.pressed(Key.ESCAPE))
			{	//Hit escape or Click on the PopupBox to close.
				OnHide();
			}
		}
		
		public override function render():void
		{
			super.render();
			
			if (false == IsShowing())
				return;
				
			var txt:Text = new Text(mMessageText);
			if (-1 == mMessageText.search("\n"))
				txt.render(FP.buffer, new Point(x - (txt.width * 0.5), y - (mMessageBox.height * 0.5) + 10), world.camera);
			else
				txt.render(FP.buffer, new Point(x - (mMessageBox.width * 0.5) + 10, y - (mMessageBox.height * 0.5) + 10), world.camera);
		}
		
		private static function OnHide(makeSound:Boolean = true):void
		{
			mMessageBox.visible = false;
			
			if (true == makeSound && false == mSfxOnClose.playing)
				mSfxOnClose.play();
		}

		private static function OnShow(makeSound:Boolean = true):void
		{
			mMessageBox.visible = true;
			
			if (true == makeSound && false == mSfxOnOpen.playing)
				mSfxOnOpen.play();
		}
	}
}