package ui
{
	import defines.Assets;
	import flash.geom.Rectangle;
	import net.flashpunk.FP;
	import net.flashpunk.Entity;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.utils.Input;
	import ui.BasicBtn;

	public class RestartBtn extends BasicBtn
	{
		private const COOL_DOWN:Number = 0.0;
		private const COLOR_DISABLED:uint = 0xFF808080;
		private const COLOR_ENABLED:uint = 0xFFFFFFFF;
		private var mCoolDownTimer:Number = -1.0;
		
		public function RestartBtn(atX:Number = 0, atY:Number = 500)
		{
			super(atX, atY);
			mImage = new Image(Assets.GAME_INTERFACE, new Rectangle(0, 0, 64, 64));

			mImage.centerOrigin();
			setHitbox(64, 64, 32, 32);
			
			addGraphic(mImage);
		}
		
		private function IsEnabled():Boolean
		{
			if (GameWorld.GetInstance().GetActionsLeft() == GameWorld.GetInstance().GetActionsPerRound() && 0 == GameWorld.GetInstance().GetRoundsPlayed()) return false;
			if (1 == GameWorld.GetInstance().GetCurrentLevel() && GameWorld.GetInstance().GetRoundsPlayed() < 5)	return false;
			if (PopupBox.IsShowing() || mCoolDownTimer >= 0.0)	return false;		//HACK-ish: Don't click non-PopupBoxBtn's if popup is up.
			return true;
		}
		
		protected override function OnMouseClick():Boolean
		{	//More hackery: For the tutorial...
			if (false == IsEnabled())
				return false;
			
			var world:GameWorld = GameWorld.GetInstance();
			world.ReloadLevel();
			
			mCoolDownTimer = COOL_DOWN;
			mImage.color = COLOR_DISABLED;
			return true;
		}
		
		override public function update():void
		{
			super.update();
			
			if (mCoolDownTimer >= 0.0)
			{
				mCoolDownTimer -= FP.elapsed;
				if (mCoolDownTimer < 0.0)
					mImage.color = COLOR_ENABLED;
			}
			
			if (false == IsEnabled())
				mImage.color = COLOR_DISABLED;
			else
				mImage.color = COLOR_ENABLED;
		}
	}
}